import java.util.ArrayList;
import java.util.Collection;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToMany;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;

@Entity
public class Customer implements java.io.Serializable {

  @Id
  @GeneratedValue
  private int id;

  private String firstName;

  @OneToOne(cascade = { CascadeType.ALL })
  @JoinColumn(name = "ADDRESS_ID")
  private Address address;

  @OneToMany(cascade = { CascadeType.ALL })
  @JoinColumn(name = "CUSTOMER_ID")
  private Collection<Phone> phoneNumbers = new ArrayList<Phone>();

  @OneToOne(cascade = { CascadeType.ALL })
  private CreditCard creditCard;

  @ManyToMany(mappedBy = "customers")
  private Collection<Reservation> reservations = new ArrayList<Reservation>();

  public int getId() {
    return id;
  }

  public void setId(int id) {
    this.id = id;
  }

  public String getFirstName() {
    return firstName;
  }

  public void setFirstName(String firstName) {
    this.firstName = firstName;
  }

  public Address getAddress() {
    return address;
  }

  public void setAddress(Address address) {
    this.address = address;
  }

  public CreditCard getCreditCard() {
    return creditCard;
  }

  public void setCreditCard(CreditCard card) {
    creditCard = card;
  }

  public Collection<Phone> getPhoneNumbers() {
    return phoneNumbers;
  }

  public void setPhoneNumbers(Collection<Phone> phones) {
    this.phoneNumbers = phones;
  }

  public Collection<Reservation> getReservations() {
    return reservations;
  }

  public void setReservations(Collection<Reservation> reservations) {
    this.reservations = reservations;
  }
}
